<?php
//TITLE=AVI animation creator

$title = 'AVI animation creator';
$progname = 'animmaker';

function usagetext($prog)
{
  exec($prog.' --help', $kk);
  $k='';foreach($kk as $s)$k.="$s\n";
  return $k;
}

$text = array(
   'purpose:1. Purpose' => "

Creates an unindexed raw AVI from a stack of uncompressed RGB24
Targa files (the ones generated by POV-Ray are accepted perfectly).<p>
After having a raw AVI file generated by animmaker, you can encode it
to DivX with <a href=\"http://www.mplayerhq.hu/\">MPlayer</a>, like this:

<pre class=smallerpre
>mencoder foo.avi -o foo2.avi -divx4opts br=800:q=5:key=25</pre>

Or if you prefer libavcodec instead of divx4linux and two-pass
encoding (enhances the quality/size ratio), you can do it like this:

<pre class=smallerpre
>mencoder foo.avi -o foo2.avi -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=800:vhq:vpass=1
mencoder foo.avi -o foo2.avi -ovc lavc -lavcopts vcodec=mpeg4:vbitrate=800:vhq:vpass=2</pre>

Refer to the mencoder documentation to see how you can add audio, use different
codecs, tune the compression parameters etc. Note that not all codecs support
two pass encoding, which is completely optional anyway.

", 'usage:1. Usage' => "

<pre class=smallerpre>".htmlspecialchars(usagetext('animmaker'))."</pre>

", 'povrayexample:1. Povray example' => "

This is an example of making an animation in povray as DivX.<br>
<pre class=smallerpre
>\$ cat &gt;animmakerdemo.pov &lt;&lt;EOF
plane { y,-1 pigment { checker rgb 1, rgb .5 } }
sphere { 0,1 pigment { rgbf .8 } finish { specular 0.3 ambient 0.3 } interior { ior 1.3 } }
camera { location x*10 look_at 0 angle 35            rotate y*360*clock    }
light_source { 0, 1 fade_power 2 fade_distance 10
               looks_like { sphere { 0,0.2 pigment { rgb 1 } finish { ambient 1 } } }
               translate &lt;6,1,0&gt; rotate y*360*clock*-4
             }
EOF
\$ povray +w320 +h200 +kff300 +ft +ianimmakerdemo.pov
\$ animmaker -f20 -oanimmakerdemo.avi animmakerdemo???.tga
\$ mencoder animmakerdemo.avi -o animmakerdemo1.avi -divx4opts br=400:q=5:key=100 -pass 1
\$ mencoder animmakerdemo.avi -o animmakerdemo2.avi -divx4opts br=400:q=5:key=100 -pass 2
</pre>
Result is a <a href=\"/src/animmakerdemo2.avi\">nice looping animation</a>.<br>
(Time for render total: 357 seconds; time for encode total: 239 seconds.)
<p>
If you wish to include audio with your animation, add
<code>-audiofile &lt;filename&gt;</code> to your mencoder commandlines.<br>
See the manual pages of each programs regarding the use of them.

", 'limits:1. Limits' => "

<ul>
 <li>All input tga files must be the same resolution.</li>
 <li>Only uncompressed rgb24 tga files are accepted.</li>
 <li>No index will be created to the avi file.</li>
 <li>Resulting avi may not be bigger than 2 GB.</li>
</ul>

", 'features:1. Features' => "

<ul>
 <li>Any frame rate can be selected between 0.00023 and 1000000 fps.</li>
 <li>Any number of frames is accepted (though the OS may limit the number of parameters).</li>
</ul>

", 'todo:1. To do' => "

These features might be implemented some day:
<ul>
 <li>Runtime conversion of any image format (using ImageMagick, obsoletes the requirement of tga files)</li>
 <li>Audio support</li>
</ul>

", 'copying:1. Copying' => "

animmaker has been written by Joel Yliluoma, a.k.a.
<a href=\"http://bisqwit.iki.fi/\">Bisqwit</a>,<br>
and is distributed under the terms of the
<a href=\"http://www.gnu.org/licenses/licenses.html#GPL\">General Public License</a> (GPL).<br>
Some features contributed by <a href=\"http://iki.fi/warp/\">Warp</a>.
<p>
If you happen to see this program useful for you, I'd
appreciate if you tell me :) Perhaps it would motivate
me to enhance the program.

", 'contribute:1. Contribute!' => "

You can contribute!

<ul>
 <li>Add new features, fix bugs! Modify the
     program (the source code!) and send me
     the patches.</li>
 <li>If you have a nice short (6-8 lines) povray
     animation scene to replace that crappy one
     of mine here on this page, you can send it
     to me too :)</li>
</ul>
My email address (sigh) is: <em>bisqwit a<b style=\"font-weight:lighter\">t i</b>ki <small>dot</small> fi</em>.

", '1. Requirements' => "

GNU make is probably required.

", '1. Installation' => "

<pre class=smallerpre
>\$ make
\$ su
# make install</pre>

If you do not want to install
<a href=\"http://oktober.stc.cx/source/libargh.html\">libargh</a>
(included in the archive), do not use \"make install\" and edit
Makefile and enable the STATIC linking instead of DYNAMIC.

");
include '/WWW/progdesc.php';
